// Author: Pierre Lombard <pierre.lombard@imag.fr>
// Date: 2001/2002
// License: GPLv2

#ifndef __CLIENT_COMMON_H__
#define __CLIENT_COMMON_H__ 1

/**
 * timed_setsock - establishes a connection with a timeout
 * 
 * @host: hostname (the name resolution has no timeout!!!)
 * @service: port ("4242") or service name ("telnet") as in /etc/services
 * @proto: protocol ("tcp", "udp", ...) (this is not really useful for udp indeed ;)
 * @timeout_ms: timeout in milliseconds (if 0 => system settings)
 */
int timed_setclientsock(const char * const host, const char * const service, const char * const proto, unsigned long timeout_ms);


/**
 * setsock - calls timed_setsock with 0 timeout (system settings)
 * 
 */
int setclientsock(const char * const host, const char * const service, const char * const proto);

#endif /* !__CLIENT_COMMON_H__ */
